<?php

namespace Skript\WpInstaller\Templates;

function wpConfig(string $wpConfigPath, string $autoloadPath): string
{
    return <<<EOT
<?php

/**
 * WARNING: DON'T EDIT THIS FILE!
 *
 * This file is generated by the wordpress-installer. Change your config in
 * {$wpConfigPath} instead.
 */

/** Load composer **/
require_once __DIR__."/{$autoloadPath}";

/** Load custom config **/
require_once __DIR__."/{$wpConfigPath}";

/** Absolute path to the WordPress directory. */
if ( ! defined( 'ABSPATH' ) ) {
	define( 'ABSPATH', dirname( __FILE__ ) . '/' );
}

/** Sets up WordPress vars and included files. */
require_once( ABSPATH . 'wp-settings.php' );

EOT;
}

function wpConfigCustom(string $wpSalts): string
{
    return <<<EOT
<?php

/**
 * Loads local environment variables from file.
 *
 * Use `vendor/bin/dump-env .env` > .env.php to generate this file
 */
@include __DIR__.'/.env.php';

/**
 * The base configuration for WordPress
 */

/**
 * Database credentials
 */
define('DB_NAME',       getenv('WP_DB_NAME'));
define('DB_USER',       getenv('WP_DB_USER'));
define('DB_PASSWORD',   getenv('WP_DB_PASSWORD'));
define('DB_HOST',       getenv('WP_DB_HOST') ?: 'localhost');
define('DB_CHARSET',    getenv('WP_DB_CHARSET') ?: 'utf8');
define('DB_COLLATE',    getenv('WP_DB_COLLATE') ?: '');

/**
 * WordPress Database Table prefix.
 *
 * You can have multiple installations in one database if you give each
 * a unique prefix. Only numbers, letters, and underscores please!
 */
\$table_prefix = getenv('WP_TABLE_PREFIX') ?: 'wp_';

/**#@+
 * Authentication Unique Keys and Salts.
 *
 * Change these to different unique phrases!
 * You can generate these using the {@link https://api.wordpress.org/secret-key/1.1/salt/ WordPress.org secret-key service}
 * You can change these at any point in time to invalidate all existing cookies. This will force all users to have to log in again.
 *
 * @since 2.6.0
 */
{$wpSalts}

/**
 * For developers: WordPress debugging mode.
 *
 * Change this to true to enable the display of notices during development.
 * It is strongly recommended that plugin and theme developers use WP_DEBUG
 * in their development environments.
 *
 * For information on other constants that can be used for debugging,
 * visit the Codex.
 *
 * @link https://codex.wordpress.org/Debugging_in_WordPress
 */
define('WP_DEBUG', getenv('WP_DEBUG') ?: false);

/**
 * Updates and editor settings
 */
define('DISALLOW_FILE_EDIT', true); // disables plugin and theme editor
define('DISALLOW_FILE_MODS', true); // disables plugin and theme updates

// disables **automatic** core updates
define('AUTOMATIC_UPDATER_DISABLED', true);
define('WP_AUTO_UPDATE_CORE', false);

EOT;
}

function defaultSalts(): string
{
    return <<<EOT
define('AUTH_KEY',         'put your unique phrase here');
define('SECURE_AUTH_KEY',  'put your unique phrase here');
define('LOGGED_IN_KEY',    'put your unique phrase here');
define('NONCE_KEY',        'put your unique phrase here');
define('AUTH_SALT',        'put your unique phrase here');
define('SECURE_AUTH_SALT', 'put your unique phrase here');
define('LOGGED_IN_SALT',   'put your unique phrase here');
define('NONCE_SALT',       'put your unique phrase here');
EOT;
}

/**
 * Autoloading...
 */
namespace Skript\WpInstaller;

class Templates
{
    public static function wpConfig(...$args)
    {
        return Templates\wpConfig(...$args);
    }

    public static function wpConfigCustom(...$args)
    {
        return Templates\wpConfigCustom(...$args);
    }

    public static function defaultSalts(...$args)
    {
        return Templates\defaultSalts(...$args);
    }
}
